<template>
  <q-page>
    <q-no-ssr>
      <div class="q-pa-md row">
        <div class="q-pa-sm col-md-4">
          <div class="q-my-md">
            <div class="text-h6">Kategori</div>
            <div class="text-white">
              <q-btn
                flat
                :class="
                  'q-ma-xs ' +
                  (store.category_id === 0 ? 'bg-orange' : 'bg-pink')
                "
                @click="store.setCategory(0)"
                >Semua</q-btn
              >
              <q-btn
                flat
                :class="
                  'q-ma-xs ' +
                  (store.category_id === category.id ? 'bg-orange' : 'bg-pink')
                "
                v-for="category in store.categories"
                :key="category.id"
                @click="store.setCategory(category.id)"
                >{{ category.name }} [{{ category.count }}]</q-btn
              >
            </div>
          </div>
          <div class="q-my-md">
            <div class="text-h6">Tags</div>
            <div class="q-gutter-xs">
              <q-btn
                no-caps
                dense
                flat
                :class="
                  (store.tag_id === 0 ? 'bg-green' : 'bg-grey') + ' text-white'
                "
                @click="store.setTag(0)"
                >Semua Tag</q-btn
              >
              <q-btn
                no-caps
                dense
                flat
                :class="
                  (store.tag_id === tag.id ? 'bg-green' : 'bg-grey') +
                  ' text-white'
                "
                @click="store.setTag(tag.id)"
                v-for="tag in store.tags"
                :key="tag.id"
                >{{ tag.name }} ({{ tag.count }})</q-btn
              >
            </div>
          </div>
        </div>
        <div class="q-pa-sm col-md-8">
          <div class="q-pa-md">
            <q-input
              :debounce="500"
              color="purple"
              outlined
              v-model="store.search"
              label="Pencarian"
              @update:model-value="store.fetchItems"
            >
              <template v-slot:append>
                <q-icon name="search" />
              </template>
            </q-input>
          </div>

          <div class="row" v-if="store.items.length === 0">
            <div class="text-center col-xs-12">Hasil Tidak Ditemukan</div>
          </div>
          <div class="row" v-else>
            <div class="col-xs-12">
              <q-pagination
                v-model="store.page"
                class="q-ma-md"
                :max="Math.ceil(store.count / store.limit)"
                :max-pages="9"
                direction-links
                @update:model-value="store.fetchItems()"
              />
            </div>
            <div
              class="col-md-6 col-xs-12"
              v-for="item in store.items"
              :key="item.slug"
            >
              <q-card class="q-ma-md" bordered flat>
                <router-link :to="'/blog/' + item.slug">
                  <image-view
                    :src="item.thumbnail"
                    :alt="placeholderImages.post"
                    :ratio="2"
                  />
                </router-link>
                <q-card-section>
                  <router-link :to="'/blog/' + item.slug">
                    <div class="text-h5">{{ item.title }}</div>
                  </router-link>
                  <div class="text-grey">
                    {{ item.description }}
                  </div>
                </q-card-section>
              </q-card>
            </div>
          </div>
        </div>
      </div>
    </q-no-ssr>
  </q-page>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import { useHomeBlogStore } from 'stores/home-blog';
import { placeholderImages } from 'src/boot/placeholder';
import ImageView from 'src/components/ImageView.vue';

export default defineComponent({
  name: 'BlogPage',

  components: {
    ImageView,
  },
  setup() {
    const store = useHomeBlogStore();
    store.fetchFilters();
    store.fetchItems();

    return { store, placeholderImages };
  },
});
</script>
